var gATL = {	// written by Tom Kennedy

sVrsn: "#version#",
sDATE: "#date#",
sSECN: "#seconds#",
sLSSN: "#lesson#",
sAVRG: "#avg_score#",	 //  Constants, to seperate the data in addictive_typing_lessons_data.txt
sHIGH: "#hii_score#",
s_LOW: "#low_score#",
AV_ER: "#avg_error#",
s_SCR: "#scores#",
s_ERR: "#errors#", 
sFont: "#font_size#",
					//  for more compact code
txtPrompt:  null,	//  for document.getElementById('txt_prompt')
txtAnswer:  null,	//  for document.getElementById('txt_answer')
lblScores:  null,	//  for document.getElementById('lbl_scores')
lblErrors:  null,	//  for document.getElementById('lbl_errors')
lblCurrent: null,	//  for document.getElementById('lbl_averages_current')
lblBest:	null,	//  for document.getElementById('lbl_averages_best')
lblStint:	null,	//  for document.getElementById('lbl_time_typing_stint')
lblTotal:	null,	//  for document.getElementById('lbl_time_typing_today')
lessonsPop1: null,  //  for document.getElementById('mnu_lessonsPopup-1')
lessonsPop2: null,  //  for document.getElementById('mnu_lessonsPopup-2')
fontMenu:   null,   //  for document.getElementById('mnu_fonts')
chkInvisible: null, //  for document.getElementById("chk_invisible")
backspaceMenu: null, // for document.getElementById("menuList_backspace")

stint_seconds : 0,  // time spent typing, set to zero at every open
stint_minutes : 0,
stint_hours   : 0,
stint_sec_mod : 0,
stint_min_mod : 0,
total_seconds : 0,  //  time spent typing, set to zero each new day
total_minutes : 0,
total_hours	  : 0,
total_sec_mod : 0,
total_min_mod : 0,
loaded_seconds: 0,
total_quarter_seconds: 0,

prompt : "",	// prompt is what you should type
answer : "",	// answer is what you have typed
promptLen : 0,  // prompt-length
answerLen : 0,  // answer-length
lessonNum: 0,	 //  which lesson is currently selected
seconds: 0,  
quarterSeconds: 0,
theDate : "",	//  To determine if typing-time-today should start at zero.
timer	: null,	
running : false,
fileName: "addictive_typing_lessons_data.txt",  //  in the Chrome folder
wpm: 0,
errorCount: 0,  //  number of errors				Set to 0 after each drill.
avg_score : 0,
hii_score : 0,  //  scores for the current lesson
low_score : 0,
avg_error : 0,
cur_scores:  "",	//  44  53  62  56	the current scores
cur_errors:  "",	//	 6   3	 2 	 5	the current errors
oldBests :	"",	    //  for the blinking effect of a best new score
newBests :	"",

best_avg: null,         // arrays
best_hii: null,
best_low: null,
best_err: null,
scoresLines: null,
errorsLines: null, 

timeTypingString1: "0:00",
timeTypingString2: "0:00",
fontSizeIndex: 2,	       //  20px,
backgroundColor: "",
speedType: "WPM",
keysVisible: true,         // whether the keys layout display should be visible
invisibleTyping: false,    // whether the letters being typed in should be visible
typedVisibleCorrectly: 0,  // used to count the number of correctly typed letters, if invisible typing is checked, so that after 6, make invisible again
backspaceNumIndex: 0,      // which menu item of backspace menu is selected : values 0 1 2 3 4 5 6 7
backspaceNum: 1,           // is set with the backspace menu; how much to backspace on error : values: 1 3 5 7 10 20 30 80
txtPromptWidth: 776,	   // used to change the prompt line when the user is stretching or shrinking the window width

load: function() { 				//  calls FileIO.read, changeColor, loadContent, trimLessonsMenu, loadKeyboardLayout, changeTheFont, lessonChange		
	gATL.setInitialValues();	
	var f = DirIO.get('UChrm');
	f.append(gATL.fileName);    //  addictive_typing_lessons_data.txt in the Chrome folder
	if(f.exists())	{
		try {
			var input	 = FileIO.read(f, "UTF-8");
			input = input.replace(/\r/g, ""); 
			input = input.replace(/\n/g, "");
			var font_ind = input.indexOf(gATL.sFont);
			var ver_indx = input.indexOf(gATL.sVrsn);
			var dat_indx = input.indexOf(gATL.sDATE);	
			var sec_indx = input.indexOf(gATL.sSECN);	
			var les_indx = input.indexOf(gATL.sLSSN);
			var avg_indx = input.indexOf(gATL.sAVRG);  
			var hii_indx = input.indexOf(gATL.sHIGH);
			var low_indx = input.indexOf(gATL.s_LOW);
			var err_indx = input.indexOf(gATL.AV_ER);
			var scrs_ind = input.indexOf(gATL.s_SCR);
			var errs_ind = input.indexOf(gATL.s_ERR);			
			var show_keys1 = input.indexOf("(__[show_the_keys]_)");
			var show_keys2 = input.indexOf("(_[show_the_keys]__)");	
			if(show_keys1 != -1 && show_keys2 != -1) {
				gATL.keysVisible = input.substring(show_keys1 + 20, show_keys2);
			}
			if(gATL.keysVisible == "false"){
				document.getElementById("keys_display").hidden = true;
			}
			else {
				document.getElementById("keys_display").hidden = false;
			}			
			var invisible1 = input.indexOf("(__[invisible_typ]_)");
			var invisible2 = input.indexOf("(_[invisible_typ]__)");	
			if(invisible1 != -1 && invisible2 != -1) {
				gATL.invisibleTyping = input.substring(invisible1 + 20, invisible2);
			}			
			if(gATL.invisibleTyping == "true"){
				gATL.chkInvisible.checked = true;
			}
			else {
				gATL.chkInvisible.checked = false;
			}						
			var backspace1 = input.indexOf("(__[backspace_num]_)");
			var backspace2 = input.indexOf("(_[backspace_num]__)");	
			if(backspace1 != -1 && backspace2 != -1) {
				gATL.backspaceNumIndex =  1 * input.substring(backspace1 + 20, backspace2);
			}
			var wpm_cpm1 = input.indexOf("(__[is_wpm_or_cpm]_)");
			var wpm_cpm2 = input.indexOf("(_[is_wpm_or_cpm]__)");
			if(wpm_cpm1 != -1 && wpm_cpm2 != -1) {
				gATL.speedType = input.substring(wpm_cpm1 + 20, wpm_cpm2);
			}
			if(gATL.speedType == "CPM") {
				document.getElementById('opt_speed_type').selectedIndex = 1;
			}			
			var in_color="";
			var bc1 = input.indexOf("(__[backgrd_color]_)");
			var bc2 = input.indexOf("(_[backgrd_color]__)");
			if(bc1 != -1 && bc2 != -1) {
				in_color = input.substring(bc1 + 20, bc2);
			}			
			if(font_ind != -1) {
				var xn = font_ind + gATL.sFont.length;
				var fnts = input.substring(xn, xn+1);  // values 0 thru 9
				gATL.fontSizeIndex = 1 * fnts;   //  make it a number
			}
			else {
				gATL.fontSizeIndex = 2;  // 20 pixels
			}	
			
			var in_version = input.substring(ver_indx + gATL.sVrsn.length, dat_indx);			
			var in_date	   = input.substring(dat_indx + gATL.sDATE.length, sec_indx);
			var in_seconds = input.substring(sec_indx + gATL.sSECN.length, les_indx);
			var in_lesson  = input.substring(les_indx + gATL.sLSSN.length, avg_indx); 
			var in_best_av = input.substring(avg_indx + gATL.sAVRG.length, hii_indx); 
			var in_best_hi = input.substring(hii_indx + gATL.sHIGH.length, low_indx);
			var in_best_lo = input.substring(low_indx + gATL.s_LOW.length, err_indx);
			var in_best_er = input.substring(err_indx + gATL.AV_ER.length, scrs_ind);

			gATL.lessonNum	= 1 * in_lesson;	
			
			if(in_version == "2.5" || in_version == "3.0") {           // read in scores from the previous version			
				var temp_best_avg = in_best_av.split("|"); 
				var temp_best_hii = in_best_hi.split("|");
				var temp_best_low = in_best_lo.split("|");  
				var temp_best_err = in_best_er.split("|"); 	
				for(var i = 0; i < 77; i++) {
					gATL.best_avg[i][0] = temp_best_avg[i];  // the zero array element is backspace setting of one
					gATL.best_hii[i][0] = temp_best_hii[i];  // which was the only setting available in the previous version
					gATL.best_low[i][0] = temp_best_low[i];  
					gATL.best_err[i][0] = temp_best_err[i];
				}				
				if(scrs_ind != -1 && errs_ind != -1) {
					var in_scores  = input.substring(scrs_ind + gATL.s_SCR.length, errs_ind);
					var in_errors  = input.substring(errs_ind + gATL.s_ERR.length, input.length);
					var temp_scoresLines = in_scores.split("|"); 
					var temp_errorsLines = in_errors.split("|");	
					for(var i = 0; i < 77; i++) {
						gATL.scoresLines[i][0] = temp_scoresLines[i];  // the zero array element is backspace setting of 1
						gATL.errorsLines[i][0] = temp_errorsLines[i];  // which was the only setting available in the previous version
					}					
				}
			}			
			else {											 // the current version, 3.5
				var best_avg_array = in_best_av.split("^");  // split into 77 lessons
				var best_hii_array = in_best_hi.split("^");
				var best_low_array = in_best_lo.split("^");  
				var best_err_array = in_best_er.split("^"); 					
				for(var i = 0; i < 77; i++) {						  // fills up 2-dimensional array
					gATL.best_avg[i] = best_avg_array[i].split("|");  // split into 8 sets of scores for each of 8 backspace settings
					gATL.best_hii[i] = best_hii_array[i].split("|");
					gATL.best_low[i] = best_low_array[i].split("|");  
					gATL.best_err[i] = best_err_array[i].split("|");
				}					
				if(scrs_ind != -1 && errs_ind != -1) {
					var in_scores  = input.substring(scrs_ind + gATL.s_SCR.length, errs_ind);
					var in_errors  = input.substring(errs_ind + gATL.s_ERR.length, input.length);
					var in_scores_array = in_scores.split("^");
					var in_errors_array = in_errors.split("^");				
					for(var i = 0; i < 77; i++) {				
						gATL.scoresLines[i] = in_scores_array[i].split("|"); 
						gATL.errorsLines[i] = in_errors_array[i].split("|");
					}	
				}			
			}
			
			var d = new Date();   //  for time spent typing today
			var mth = d.getMonth() + 1;
			var ddd = d.getDate();
			var yyy = d.getFullYear();	// -5 hours, so day starts at 5:00am 
			d = new Date(d.getFullYear(),d.getMonth(),d.getDate(), d.getHours()-5);
			mth = d.getMonth() + 1;
			ddd = d.getDate();
			yyy = d.getFullYear();
			gATL.theDate = "" + mth + "/" + ddd + "/" + yyy + "";
			if(in_date == gATL.theDate) {
				gATL.total_seconds = 1 * in_seconds;
				gATL.loaded_seconds = 1 * in_seconds;  
				gATL.total_quarter_seconds = 4 * gATL.total_seconds;
			}
		} catch(e) {
		} 
	}
	else if(!f.exists())	{
		FileIO.create(f);  
	}
	gATL.changeColor(in_color);
	document.getElementById("mnu_fonts").selectedIndex = gATL.fontSizeIndex;
	gATL.backspaceMenu.selectedIndex = gATL.backspaceNumIndex;	
	gATL.backspaceNum = 1 * gATL.backspaceMenu.getItemAtIndex(gATL.backspaceNumIndex).label;	
	gATLData.loadContent();
	gATL.trimLessonsMenu();
	while(gATL.lessonNum >= gATL.lessonsPop2.childNodes.length + 26) { 
		gATL.lessonNum--;    //  to make sure the current lesson is not the one at the bottom which had been deleted
	}
	if(gATL.lessonNum < 26) {
		document.getElementById('mnu_lessonsList-1').selectedIndex = gATL.lessonNum;
	}
	else {
		var userCreatedLessonNum = gATL.lessonNum - 26;
		document.getElementById("mnu_lessonsList-2").selectedIndex = -1;  //    this is what made it work for item 27 !!!
		document.getElementById('mnu_lessonsList-2').selectedIndex = userCreatedLessonNum;
	}
	gATLData.loadKeyboardDisplay(); 
	gATL.changeTheFont();
	gATL.lessonChange();
	window.moveTo(10, 10);
}, 
windowResized:   function() {  // the wider the window, the more characters can fit in the textbox
	var newWidth = parseInt(window.getComputedStyle(gATL.txtPrompt,null).width, 10);	
	if(newWidth-gATL.txtPromptWidth > 10 || newWidth-gATL.txtPromptWidth < -10) {
		gATL.txtPromptWidth = newWidth;
		if(gATL.running == false) {
			gATL.displayPrompt();
		}
	}	
	var theATLWindow = document.getElementById("addictive_typing_lessons");
	newWidth = parseInt(window.getComputedStyle(theATLWindow,null).width, 10);
},
deleteScoresOfDeletedLesson: function(lessonNumToDelete) {		// called from gATLCustom.deleteLesson()	
	gATL.scoresLines.splice(lessonNumToDelete, 1);  // remove one array of scores from each two-dimensional array
	gATL.errorsLines.splice(lessonNumToDelete, 1);
	gATL.best_avg.splice(lessonNumToDelete, 1);
	gATL.best_hii.splice(lessonNumToDelete, 1);
	gATL.best_low.splice(lessonNumToDelete, 1);
	gATL.best_err.splice(lessonNumToDelete, 1);		
	gATL.scoresLines.push(['','','','','','','','']);  // add an empty array to the end
	gATL.errorsLines.push(['','','','','','','','']);
	gATL.best_avg.push([0,0,0,0,0,0,0,0]);
	gATL.best_hii.push([0,0,0,0,0,0,0,0]);
	gATL.best_low.push([0,0,0,0,0,0,0,0]);
	gATL.best_err.push([0,0,0,0,0,0,0,0]);	  // the eight values are the scores for each of the 8 backspace option
},
setInitialValues: function() {
	gATL.lblScores     = document.getElementById('lbl_scores');
	gATL.lblErrors     = document.getElementById('lbl_errors');
	gATL.txtPrompt     = document.getElementById('txt_prompt');
	gATL.txtAnswer     = document.getElementById('txt_answer');
	gATL.lblCurrent    = document.getElementById('lbl_averages_current');
	gATL.lblBest	   = document.getElementById('lbl_averages_best');
	gATL.lblStint	   = document.getElementById('lbl_time_typing_stint');
	gATL.lblTotal	   = document.getElementById('lbl_time_typing_today');
	gATL.lessonsPop1   = document.getElementById('mnu_lessonsPopup-1');
	gATL.lessonsPop2   = document.getElementById('mnu_lessonsPopup-2');
	gATL.fontMenu      = document.getElementById('mnu_fonts');	
	gATL.chkInvisible  = document.getElementById('chk_invisible');
	gATL.backspaceMenu = document.getElementById("menuList_backspace")
	
	gATL.scoresLines = new Array(gATLData.NUM_LESSONS);
	gATL.errorsLines = new Array(gATLData.NUM_LESSONS);
	gATL.best_avg	= new Array(gATLData.NUM_LESSONS);
	gATL.best_hii	= new Array(gATLData.NUM_LESSONS);
	gATL.best_low	= new Array(gATLData.NUM_LESSONS);
	gATL.best_err	= new Array(gATLData.NUM_LESSONS);
	
	for(var i = 0; i<gATLData.NUM_LESSONS; i++) {
		gATL.scoresLines[i] = new Array(8);  // for the 8 different backspace settings
		gATL.errorsLines[i] = new Array(8);
		gATL.best_avg[i]    = new Array(8);
		gATL.best_hii[i]    = new Array(8);
		gATL.best_low[i]    = new Array(8);
		gATL.best_err[i]    = new Array(8);
	}		
	for(var i = 0; i < gATLData.NUM_LESSONS; i++) {
		for(var j = 0; j < 8; j++) {
			gATL.scoresLines[i][j] = '';
			gATL.errorsLines[i][j] = '';
			gATL.best_avg[i][j] = 0;
			gATL.best_hii[i][j] = 0;
			gATL.best_low[i][j] = 0;
			gATL.best_err[i][j] = 0;
		}
	}
},
unload: function() {               //  saves the scores file   //  calls FileIO.write()
	clearTimeout(gATL.timer);      
	gATL.total_seconds = Math.round(gATL.total_quarter_seconds/4);
	var i = 0;
	var j = 0;
	var da = new Date(); 
	da = new Date(da.getFullYear(),da.getMonth(), da.getDate(),da.getHours()-5);
	gATL.theDate = "" + (da.getMonth()+1) + "/" + da.getDate() + "/" + da.getFullYear() + "";
	var out = "";	
	out = out + "(__[show_the_keys]_)" + gATL.keysVisible          + "(_[show_the_keys]__)\r\n\r\n";
	out = out + "(__[invisible_typ]_)" + gATL.chkInvisible.checked + "(_[invisible_typ]__)\r\n\r\n";
	out = out + "(__[backspace_num]_)" + gATL.backspaceNumIndex    + "(_[backspace_num]__)\r\n\r\n";	
	out = out + "(__[is_wpm_or_cpm]_)" + gATL.speedType            + "(_[is_wpm_or_cpm]__)\r\n\r\n";
	out = out + "(__[backgrd_color]_)" + gATL.backgroundColor      + "(_[backgrd_color]__)\r\n\r\n";
	out = out + gATL.sFont + gATL.fontSizeIndex + "\r\n\r\n";	
	out = out + gATL.sVrsn + "3.5"+ "\r\n\r\n";		
	out = out + gATL.sDATE + gATL.theDate + "\r\n\r\n";
	out = out + gATL.sSECN + gATL.total_seconds + "\r\n\r\n";
	out = out + gATL.sLSSN + gATL.lessonNum + "\r\n\r\n";
	
	out = out + gATL.sAVRG + "";
	
	for(i = 0; i < gATLData.NUM_LESSONS; i++) { 
		for(j = 0; j < 8; j++) {
			out = out + gATL.best_avg[i][j] + "|"; 
		}
		out = out + "^";
	}
	out = out + "\r\n\r\n" + gATL.sHIGH;
	
	for(i = 0; i < gATLData.NUM_LESSONS; i++) { 
		for(j = 0; j < 8; j++) {
			out = out + gATL.best_hii[i][j] + "|"; 
		}
		out = out + "^";
	}
	out = out + "\r\n\r\n" + gATL.s_LOW;
	
	for(i = 0; i < gATLData.NUM_LESSONS; i++) { 
		for(j = 0; j < 8; j++) {
			out = out + gATL.best_low[i][j] + "|"; 
		}
		out = out + "^";
	}
	out = out + "\r\n\r\n" + gATL.AV_ER;
	
	for(i = 0; i < gATLData.NUM_LESSONS; i++) { 
		for(j = 0; j < 8; j++) {
			out = out + gATL.best_err[i][j] + "|"; 
		}
		out = out + "^";
	}
	out = out + "\r\n\r\n" + gATL.s_SCR;
	
	for(i = 0; i < gATLData.NUM_LESSONS; i++) {
		for(j = 0; j < 8; j++) {		 
			out = out + gATL.scoresLines[i][j] + "|";
		}
		out = out + "^";
	}
	out = out + "\r\n\r\n" + gATL.s_ERR;
	
	for(i = 0; i < gATLData.NUM_LESSONS; i++) { 
		for(j = 0; j < 8; j++) {
			out = out + gATL.errorsLines[i][j] + "|";
		}
		out = out + "^";
	}	
	out = out.replace(/undefined/g, "");
	var file = DirIO.get('UChrm');
	file.append(gATL.fileName);
	FileIO.write(file, out, 'w', "UTF-8");
},
theUserTypedArrowOrHomeKey: function(e)  {  // the user clicked the home key(to go to the start of a story) or arrow keys(next or previous line)  
	if(gATL.running == false) {
		if(e.which == 39 || e.which == 40) {     //   if the down arrow or left arrow was clicked, go to the next line
			gATL.displayPrompt(); 
		}	
		else if(gATL.lessonNum > 25 && (e.which == 37 || e.which == 38)) {
			// if the up arrow or right arrow was clicked, go to the previous line
			if(gATL.running == false)
			if(gATLData.customLinesOrderType == 0) {  // ordered lines lesson
				gATLData.linesCount = gATLData.linesCount-2;
				gATL.displayPrompt();
			}
			if(gATLData.customLinesOrderType == 2) {  // wrapped lines lesson
				gATLData.linesIndexesArrayNum = gATLData.linesIndexesArrayNum - 2;
				gATLData.linesContentsIndex = gATLData.linesIndexesArray[gATLData.linesIndexesArrayNum];
				gATL.displayPrompt();
			}
		}
		else if(e.which == 36) {   //   the home key was pressed, go to the start of the story
			if(gATLData.lessonType == 2 && gATL.lessonNum > 25) {  // if it is a lines lesson and a custom lesson
				gATLData.linesCount = 0;          // to the start of the story, if a normal order lines lesson, such as song lyrics
				gATLData.linesContentsIndex = 0;  // to the start of the story, if a wrapped lines lesson
				gATL.displayPrompt();
			}
		}
	}
},
doType: function(e)  {				// when something is typed	
	if(e.which > 35 && e.which < 41) {   // if typed an arrow key or the home key
		gATL.theUserTypedArrowOrHomeKey(e);
	}
	else if(e.which == 27) {                                     //  the user hit the escape key
		// document.getElementById("btn_endDrill").doCommand();  //  invokes the onCommand code of the End Drill button
		gATL.cancelDrillClicked();		// or do it this way
	}	                                                    
	else {
		gATL.answer = gATL.txtAnswer.value;	 //  typed so far;
		gATL.answerLen = gATL.answer.length;
		var promptBit = gATL.prompt.substring(0,gATL.answerLen);
		
		gATL.typedVisibleCorrectly++;        //  counts number correctly typed, so it can be invisible again
		if(gATL.typedVisibleCorrectly > 6 && gATL.chkInvisible.checked == true) {   
			gATL.txtAnswer.style.color = 'white';    //   change to invisible if typed since start or since last error is > 6
		}
		
		if(promptBit != gATL.answer.substring(0,gATL.answerLen+1)) {  // mistyped		
			gATL.txtAnswer.value = gATL.answer.substring(0,gATL.answerLen-gATL.backspaceNum);  // backspace on error	
			gATL.errorCount = gATL.errorCount + 1;
			
			gATL.typedVisibleCorrectly = 0;  		
			if(gATL.chkInvisible.checked == true) {    // if they are typing in invisible-mode
				gATL.txtAnswer.style.color = 'black';  // make it visible temporarily for the user to see where to type
			}			
		}  
		else if(gATL.answerLen >= gATL.promptLen) {			//  reached the end of the line?
			if(gATL.running == true && gATL.quarterSeconds > 0) {
				gATL.atEndOfTheLine();
			}
		}		                // If off, turn it on.  "The timer will start when you start typing"
		else if (gATL.running==false && (gATL.answerLen>0 && gATL.answerLen<10)) {
			if(gATL.txtPrompt.value.substring(0,1)==gATL.txtAnswer.value.substring(0,1)) {
				gATL.running = true;
				gATL.enableDisableButtons();
				gATL.txtPrompt.style.color = 'black'; // to indicate the timer is running
				gATL.txtAnswer.style.color = 'black'; 
				gATL.seconds = 0; 
				gATL.quarterSeconds = 0;
				gATL.doTimer();				//  turn on the timer 
			} 
		}
	}
},
atEndOfTheLine: function() {   // the user has typed to the end of the line
	gATL.running = false;	
	gATL.txtPrompt.disabled = true;
	gATL.txtAnswer.disabled = true;  	
	if(gATLData.lessonType == 2 && gATL.lessonNum > 25) {   // no delay for a lines lesson
		gATL.txtPrompt.disabled = false; 
		gATL.txtAnswer.disabled = false;
	}
	else {
		setTimeout("gATL.txtPrompt.disabled = false;", 300);  //  was 700
		setTimeout("gATL.txtAnswer.disabled = false;", 300);  //  was 700
	}	
	gATL.calculateWPM();
	gATL.addNewScore();
	gATL.calculateAverages();
	gATL.displayAverages();
	gATL.blinkBestScore();
	gATL.enableDisableButtons();
	gATL.updateTimeSpentTypingToday();
	gATL.clearTheValues();
	gATL.checkTheTimeOfDay();			
	if(gATLData.lessonType == 2 && gATL.lessonNum > 25) {
		gATL.displayPrompt();                     //   no delay for a lines lesson
	}
	else {
		setTimeout("gATL.displayPrompt();", 400);   //  was 1400
	}
},
lessonChange: function() {      //  called from load, lesson-clicked, font-checked, custom-option-change, window-resize-event 
	if(gATL.lessonNum < 26) {
		gATLData.changeLettersNums(gATL.lessonNum);  // sets vowel-num, end-num
		document.getElementById("lbl_keys1").value = gATLData.k1[gATL.lessonNum];
		document.getElementById("lbl_keys2").value = gATLData.k2[gATL.lessonNum];
		document.getElementById("lbl_keys3").value = gATLData.k3[gATL.lessonNum];
		document.getElementById("mnu_lessonsList-2").selectedIndex = -1;   //  deselect the other lessons menu
	}
	else {
		document.getElementById("lbl_keys1").value = gATLData.customKeysDisplay1;
		document.getElementById("lbl_keys2").value = gATLData.customKeysDisplay2;
		document.getElementById("lbl_keys3").value = gATLData.customKeysDisplay3;
		document.getElementById("mnu_lessonsList-1").selectedIndex = -1;  //  deselect the other lessons menu
	}
	gATL.newBests = "";
	gATL.avg_error = 0;
	if(gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex].length < 1) {
		gATL.lblScores.value = "";
		gATL.lblErrors.value = "";
	}
	else {
		gATL.lblScores.value = ("" + gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex]).substring(0,59);  
		gATL.lblErrors.value = ("" + gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex]).substring(0,59); 
	}	
	gATL.calculateAverages();
	gATL.displayAverages();
	gATL.lblBest.value = gATL.newBests;  
	gATL.clearTheValues();
	gATL.enableDisableButtons();
	gATL.updateTimeSpentTypingToday();
	gATL.displayPrompt();
},
displayPrompt: function() {			// called from lessonChange, cancelDrillClicked and doType   calls doPromptContent() and adjustPromptLength()
	gATL.txtPrompt.disabled = false;
	gATL.txtAnswer.disabled = false;
	gATL.txtPrompt.focus();        // to turn the focus away momentarily, in order to get the cursor to show in the textbox
	gATLData.doPromptContent();
	gATL.adjustPromptLength();	
	gATL.txtPrompt.value = gATL.prompt;
	gATL.promptLen = gATL.prompt.length;
	gATL.typedVisibleCorrectly = 0; 
	gATL.txtAnswer.value = "";
	gATL.txtAnswer.focus(); 
},

lessonMenu1Clicked: function() {     // select among the original lessons            calls lessonChange
	gATL.lessonNum = document.getElementById("mnu_lessonsList-1").selectedIndex;
	gATL.lessonChange();
},
lessonMenu2Clicked: function() {     // select among the user-created lessons        calls lessonChange
	gATL.lessonNum = document.getElementById("mnu_lessonsList-2").selectedIndex + 26;
	gATLData.linesCount = 0;          // to the start of the story, if a normal order lines lesson
	gATLData.linesContentsIndex = 0;  // to the start of the story, if a wrapped lines lesson
	gATL.lessonChange();
},
invisibleClicked: function() {       // when the Invisible Typing checkbox is clicked     calls lessonChange() 
	gATL.invisibleTyping = gATL.chkInvisible.checked; // true or false
	gATL.lessonChange();      //  in order to display a different set of scores
},
backspaceMenuClicked: function() {   // sets how many digits to backspace when there is an error   calls lessonChange
	gATL.backspaceNumIndex = gATL.backspaceMenu.selectedIndex; 	
	gATL.backspaceNum = 1 * gATL.backspaceMenu.getItemAtIndex(gATL.backspaceNumIndex).label;  //  values 1 3 5 7 10 15 25 80
	gATL.lessonChange();      //  in order to display a different set of scores 
},
fontMenuClicked: function() {        // calls changeTheFont() and lessonChange()
	gATL.changeTheFont();
	gATL.lessonChange();
}, 
changeTheFont: function() {	
	var selectedFontSize = document.getElementById("mnu_fonts").selectedItem.label + "px";	
	gATL.txtPrompt.style.fontSize = selectedFontSize;
	gATL.txtAnswer.style.fontSize = selectedFontSize;	
	gATL.fontSizeIndex = gATL.fontMenu.selectedIndex;	
	switch(gATL.fontSizeIndex){
		case 0  :	
			gATL.txtPrompt.height = "30px";
			gATL.txtPrompt.width = "765px";
			gATL.txtAnswer.height = "30px";
			gATL.txtAnswer.width = "765px";			
		break;
		case 1  :
			gATL.txtPrompt.height = "30px";
			gATL.txtPrompt.width = "765px";
			gATL.txtAnswer.height = "30px";
			gATL.txtAnswer.width = "765px";;
		break;
		case 2  : 
			gATL.txtPrompt.height = "32px";
			gATL.txtPrompt.width = "765px";
			gATL.txtAnswer.height = "32px";
			gATL.txtAnswer.width = "765px";
		break;
		case 3  :	
			gATL.txtPrompt.height = "36px";
			gATL.txtPrompt.width = "765px";
			gATL.txtAnswer.height = "36px";
			gATL.txtAnswer.width = "765px";
		break;
		case 4 :
			gATL.txtPrompt.height = "38px";
			gATL.txtPrompt.width = "775px";
			gATL.txtAnswer.height = "38px";
			gATL.txtAnswer.width = "770px";
		break;
		case 5  :
			gATL.txtPrompt.height = "45px";
			gATL.txtPrompt.width = "775px";
			gATL.txtAnswer.height = "45px";
			gATL.txtAnswer.width = "770px";		
		break;
		case 6  :
			gATL.txtPrompt.height = "55px";
			gATL.txtPrompt.width = "780px";
			gATL.txtAnswer.height = "55px";
			gATL.txtAnswer.width = "780px";	
		break;
		case 7  :
			gATL.txtPrompt.height = "60px";
			gATL.txtPrompt.width = "780px";
			gATL.txtAnswer.height = "60px";
			gATL.txtAnswer.width = "780px";		
		break;
		case 8  :
			gATL.txtPrompt.height = "70px";
			gATL.txtPrompt.width = "780px";
			gATL.txtAnswer.height = "70px";
			gATL.txtAnswer.width = "780px";		
		break;
		case 9  :			
			gATL.txtPrompt.height = "74px";
			gATL.txtPrompt.width = "780px";
			gATL.txtAnswer.height = "74px";
			gATL.txtAnswer.width = "780px";	
		break;
	}	
},
changeWPMorCPM: function(speedType) {  // display the scores as WPM or CPM    calls lessonChange()
	var multiplier = 1;
	if(gATL.speedType == "WPM" && speedType == "CPM") {  //  change from WPM to CPM
		multiplier = 5;
	}
	if(gATL.speedType == "CPM" && speedType == "WPM") {  // change from CPM to WPM
		multiplier = 0.2;
	}	
	gATL.speedType = speedType;
	if(multiplier != 1) {
		for(var i = 0; i < gATLData.NUM_LESSONS; i++) {
			gATL.best_avg[i][gATL.backspaceNumIndex] = gATL.best_avg[i][gATL.backspaceNumIndex] * multiplier;
			gATL.best_hii[i][gATL.backspaceNumIndex] = gATL.best_hii[i][gATL.backspaceNumIndex] * multiplier;
			gATL.best_low[i][gATL.backspaceNumIndex] = gATL.best_low[i][gATL.backspaceNumIndex] * multiplier;
			if(gATL.best_avg[i][gATL.backspaceNumIndex] != 0) {
				gATL.best_avg[i][gATL.backspaceNumIndex] = gATL.best_avg[i][gATL.backspaceNumIndex].toFixed(1);
			}
			gATL.best_hii[i][gATL.backspaceNumIndex] = Math.round(gATL.best_hii[i][gATL.backspaceNumIndex]);
			gATL.best_low[i][gATL.backspaceNumIndex] = Math.round(gATL.best_low[i][gATL.backspaceNumIndex]);
			
			var scorLine = gATL.scoresLines[i][gATL.backspaceNumIndex]; 
			scorLine = scorLine.replace(/  /g, " ");
			scorLine = scorLine.replace(/  /g, " ");	// remove double blanks  
			if(''+scorLine.charAt(0)==' ') {
				scorLine = scorLine.substring(1, scorLine.length);
			}
			var scorsArray = scorLine.split(" ");
			var newScoresLine = "";
			for(var sc = 0; sc < scorsArray.length-1; sc++) {
				scorsArray[sc] = scorsArray[sc] * multiplier;
				scorsArray[sc] = Math.round(scorsArray[sc]);
				if(scorsArray[sc] < 10)	   {scorsArray[sc] = "  " + scorsArray[sc];}
				else if(scorsArray[sc]<100){scorsArray[sc] = " "  + scorsArray[sc];}
				newScoresLine = newScoresLine + scorsArray[sc] + " ";
			}
			gATL.scoresLines[i][gATL.backspaceNumIndex] = newScoresLine;
		}	
	}
	// gATL.setStoryIndexToZero();
	gATL.lessonChange();
},
cancelDrillClicked: function() {	 // cancel-drill button clicked or user hit esc key   calls clearTheValues, enableDisableButtons, displayPrompt
	gATL.clearTheValues();
	gATL.enableDisableButtons();
	setTimeout("gATL.displayPrompt();", 800);   //  was 1400
},

erase1Score: function() {       // erase-1-score clicked,  slide values leftward  calls enableDisableButtons() and calculateAverages() and displayAverages()
	gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex] = gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex].substring(4,60);
	gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex] = gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex].substring(4,60);
	gATL.lblScores.value            = '    ' + gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex]; 
	gATL.lblErrors.value            = '    ' + gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex];
	setTimeout("gATL.lblScores.value= '   '  + gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex];", 200);
	setTimeout("gATL.lblErrors.value= '   '  + gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex];", 200);
	setTimeout("gATL.lblScores.value= '  '	 + gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex];", 250);
	setTimeout("gATL.lblErrors.value= '  '	 + gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex];", 250); 
	setTimeout("gATL.lblScores.value= ' '	 + gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex];", 300);
	setTimeout("gATL.lblErrors.value= ' '	 + gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex];", 300);
	setTimeout("gATL.lblScores.value= ''	 + gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex];", 350);
	setTimeout("gATL.lblErrors.value= ''	 + gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex];", 350);  
	document.getElementById("btn_erase1").disabled = true;
	setTimeout("gATL.enableDisableButtons();", 700); 
	gATL.calculateAverages(); 
	setTimeout("gATL.displayAverages();", 1000);
},
eraseScores: function() {		// when erase-scores button is clicked            calls enableDisableButtons()
	gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex] = "";
	gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex] = "";
	gATL.lblScores.value = "";
	gATL.lblErrors.value = "";
	gATL.lblCurrent.value = "";
	gATL.enableDisableButtons(); 
},
eraseBestScores: function() {	// when erase-best-scores button is clicked       calls enableDisableButtons()
	gATL.best_avg[gATL.lessonNum][gATL.backspaceNumIndex] = 0;
	gATL.best_hii[gATL.lessonNum][gATL.backspaceNumIndex] = 0;
	gATL.best_low[gATL.lessonNum][gATL.backspaceNumIndex] = 0;
	gATL.best_err[gATL.lessonNum][gATL.backspaceNumIndex] = 0;
	gATL.oldBests = "";
	gATL.newBests = "";
	gATL.lblBest.value = "";  
	gATL.enableDisableButtons(); 
},

buttonHideKeysClicked: function() {  // when the hide-keys button is clicked        txtAnswer.focus()
	var hbox   = document.getElementById("keys_display");  // the keys display
	if(gATL.keysVisible == "true" || gATL.keysVisible == true){  //  hide the keys
		gATL.keysVisible = false;
		hbox.hidden = true;
	}
	else {                        // show the keys
		gATL.keysVisible = true;
		hbox.hidden = false;
	}
	gATL.txtAnswer.focus();	
},
designLessonsClicked: function() {          // opens the design-lessons window
	var args = "chrome,centerscreen, resizable=yes, dialog=no, modal=no"	
	var chromeFileName = "chrome://addictive_typing_lessons/content/addictive_typing_lessons_custom.xul";	
	window.open( chromeFileName, 'addictive-typing-options', args);
},

changeColor:            function(selectedColor) {    //  txtAnswer.focus()
	var theColor = selectedColor;
	if(gATL.backgroundColor != '') {
		theColor = '';
	}
	gATL.backgroundColor = theColor;
	document.getElementById("addictive_typing_lessons").style.backgroundColor = theColor;
	document.getElementById("atl_color_picker_button").color = theColor;
	gATL.txtAnswer.focus();
},
iconClicked: function(e) {	         // when the toolbar button is clicked, to start the program	
	var args = "chrome,resizable=yes,dialog=no,modal=no,centerscreen,width=790,height=562";	
	var winContent = window.open('chrome://addictive_typing_lessons/content/addictive_typing_lessons.xul','typing-lessons', args);  
	winContent.focus();           //  if the user clicks the icon when ATL is already open, it will bring it to the front 
},
openLink: function(URL) {            // open html page in new tab when link is clicked. Different instructions pages for different links.
	if(!URL){return;}	
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var win = wm.getMostRecentWindow("navigator:browser");
	var gATLGetBrowser = win.getBrowser();
	var currBlank = (gATLGetBrowser &&
	(gATLGetBrowser.mCurrentTab.linkedBrowser && (gATLGetBrowser.mCurrentTab.linkedBrowser.contentDocument.location == "about:blank")) ||
	(!gATLGetBrowser.mCurrentTab.linkedBrowser && (gATLGetBrowser.mCurrentTab.label == "(Untitled)")));
	if (currBlank)  {
		var resultsWindow = win.loadURI(URL);
	} else {
		// var resultsWindow = win.openNewTabWith(URL, this.docURL, null, null);
		gATLGetBrowser.selectedTab = gATLGetBrowser.addTab(URL);
	}
	return true;
},
clearTheValues: function() {	     // called from lessonChange and from cancelDrillClicked
	clearTimeout(gATL.timer);
	gATL.running = false;
	gATL.txtPrompt.style.color = 'gray';
	gATL.txtAnswer.style.color = 'gray';
	gATL.seconds  = 0;
	gATL.wpm = 0;
	gATL.errorCount = 0;
	gATL.txtPrompt.value = "";
	gATL.txtAnswer.value = ""; 
},
enableDisableButtons : function() {  // while a person is typing, the buttons are disabled and the labels are gray
	var setBlackOrGray = "black";
	var disableButtons = false;	
	if(gATL.running == true) {
		setBlackOrGray = "gray";
		disableButtons = true;
	} 
	else {
		if(gATL.avg_score != 0 && gATL.avg_score != "NaN") {
			document.getElementById("btn_erase" ).disabled = false;
			document.getElementById("btn_erase1").disabled = false;
		}
		else {
			document.getElementById("btn_erase" ).disabled = true;
			document.getElementById("btn_erase1").disabled = true;
		}
		if(gATL.best_avg[gATL.lessonNum][gATL.backspaceNumIndex]!=0 && gATL.best_avg[gATL.lessonNum][gATL.backspaceNumIndex]!="NaN"){
			document.getElementById("btn_eraseBest").disabled = false;
		}
		else {
			document.getElementById("btn_eraseBest").disabled = true;
		}	
	}
	document.getElementById("btn_endDrill" ).disabled = !disableButtons;
	document.getElementById("chk_invisible").disabled = disableButtons;
	document.getElementById("btn_erase"     ).disabled = disableButtons;
	document.getElementById("btn_erase1"    ).disabled = disableButtons;
	document.getElementById("btn_eraseBest"	).disabled = disableButtons;
	document.getElementById("mnu_lessonsList-1" ).disabled = disableButtons;
	document.getElementById("mnu_lessonsList-2" ).disabled = disableButtons;		
	document.getElementById("menuList_backspace").disabled = disableButtons;
	document.getElementById("lnk_instructions").disabled = disableButtons;
	document.getElementById("mnu_fonts").disabled = disableButtons;
	document.getElementById("atl_color_button").disabled = disableButtons;
	document.getElementById("atl_color_picker_button").hidden = disableButtons;
	document.getElementById("atl_design_lessons_button").disabled = disableButtons;
	document.getElementById("atl_font_size_label").disabled = disableButtons;
	document.getElementById("opt_speed_type").disabled = disableButtons;
	document.getElementById("lbl_backspace").style.color = setBlackOrGray;
	document.getElementById("lbl_scores").style.color = setBlackOrGray;
	document.getElementById("lbl_errors").style.color = setBlackOrGray;		
	document.getElementById("lbl_avg_blank").style.color = setBlackOrGray;
	document.getElementById("lbl_avg_current").style.color = setBlackOrGray;
	document.getElementById("lbl_avg_best").style.color = setBlackOrGray;
	document.getElementById("lbl_avg_avg").style.color = setBlackOrGray;
	document.getElementById("lbl_avg_hi").style.color = setBlackOrGray;
	document.getElementById("lbl_avg_low").style.color = setBlackOrGray;
	document.getElementById("lbl_avg_err").style.color = setBlackOrGray;
	document.getElementById("lbl_averages_current").style.color = setBlackOrGray;
	document.getElementById("lbl_averages_best").style.color = setBlackOrGray;
	gATL.txtAnswer.focus();
}, 
adjustPromptLength: function() {	 // how many letters fit it in the textbox depends on the font size
	var theLimit = gATLData.getLineLimit();	
	var lastSpace = 100;	
	if(gATL.prompt.length >= theLimit) {  // the sentence is too long
		gATL.prompt = gATL.prompt.substring(0, theLimit);
		lastSpace = gATL.prompt.lastIndexOf(" ");
		if(lastSpace > theLimit-15) {
			gATL.prompt = gATL.prompt.substring(0, lastSpace);
		}
	}
	gATL.txtPrompt.value = gATL.prompt;
},
blinkBestScore: function() {         
	gATL.oldBests = gATL.lblBest.value;
	gATL.lblBest.value = gATL.newBests; 
	if(gATL.oldBests != gATL.newBests && gATL.oldBests != "") {  
		setTimeout("gATL.lblBest.value = gATL.oldBests;", 1000);
		setTimeout("gATL.lblBest.value = gATL.newBests;", 1400);
		setTimeout("gATL.lblBest.value = gATL.oldBests;", 1800);
		setTimeout("gATL.lblBest.value = gATL.newBests;", 2200); 
		setTimeout("gATL.lblBest.value = gATL.oldBests;", 2600);
		setTimeout("gATL.lblBest.value = gATL.newBests;", 3000); 
		setTimeout("gATL.lblBest.value = gATL.oldBests;", 3400);
		setTimeout("gATL.lblBest.value = gATL.newBests;", 3800);
		setTimeout("gATL.lblBest.value = gATL.oldBests;", 4200);
		setTimeout("gATL.lblBest.value = gATL.newBests;", 4600);
	}
},
doTimer: function() {
	gATL.quarterSeconds++;
	gATL.total_quarter_seconds++;
	if(gATL.running == true) {  
		clearTimeout(gATL.timer);
		gATL.timer = setTimeout('gATL.doTimer();', 250);  // one-fourth of a second
	}
},

addNewScore: function() {
	if(gATL.wpm != 0 && gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex].length > 57) {
		gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex]=gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex].substring(4,60) + gATL.wpm + " ";
		gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex]=gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex].substring(4,60) + gATL.errorCount + " ";
		gATL.cur_scores = gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex];  
		gATL.cur_errors = gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex];	// lines to slide scores left		
		gATL.lblScores.value = '    ' + gATL.cur_scores.substring(0,55);
		gATL.lblErrors.value = '    ' + gATL.cur_errors.substring(0,55);		
		if(gATLData.lessonType == 2 && gATL.lessonNum > 25) {
			// gATL.lblScores.value = '' + gATL.cur_scores.substring(0,59);
			// gATL.lblErrors.value = '' + gATL.cur_errors.substring(0,59);
			setTimeout("gATL.lblScores.value = '   ' + gATL.cur_scores.substring(0,56);",100);  // animation: the scores sliding over
			setTimeout("gATL.lblErrors.value = '   ' + gATL.cur_errors.substring(0,56);",100);  // story lesson : slides over faster
			setTimeout("gATL.lblScores.value = '  '	 + gATL.cur_scores.substring(0,57);",200);
			setTimeout("gATL.lblErrors.value = '  '	 + gATL.cur_errors.substring(0,57);",200); 
			setTimeout("gATL.lblScores.value = ' '	 + gATL.cur_scores.substring(0,58);",300);
			setTimeout("gATL.lblErrors.value = ' '	 + gATL.cur_errors.substring(0,58);",300);
			setTimeout("gATL.lblScores.value = ''	 + gATL.cur_scores.substring(0,59);",400);
			setTimeout("gATL.lblErrors.value = ''	 + gATL.cur_errors.substring(0,59);",400);
		}
		else {
			setTimeout("gATL.lblScores.value = '   ' + gATL.cur_scores.substring(0,56);",400);  // animation: the scores sliding over
			setTimeout("gATL.lblErrors.value = '   ' + gATL.cur_errors.substring(0,56);",400);
			setTimeout("gATL.lblScores.value = '  '	 + gATL.cur_scores.substring(0,57);",500);
			setTimeout("gATL.lblErrors.value = '  '	 + gATL.cur_errors.substring(0,57);",500); 
			setTimeout("gATL.lblScores.value = ' '	 + gATL.cur_scores.substring(0,58);",600);
			setTimeout("gATL.lblErrors.value = ' '	 + gATL.cur_errors.substring(0,58);",600);
			setTimeout("gATL.lblScores.value = ''	 + gATL.cur_scores.substring(0,59);",700);
			setTimeout("gATL.lblErrors.value = ''	 + gATL.cur_errors.substring(0,59);",700);
		}
	}
	else {
		gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex] = gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex] + gATL.wpm + " ";
		gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex] = gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex] + gATL.errorCount + " ";
		gATL.lblScores.value = gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex].substring(0,59);  
		gATL.lblErrors.value = gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex].substring(0,59);
	}
},
calculateAverages: function() {
	var scrLine = gATL.scoresLines[gATL.lessonNum][gATL.backspaceNumIndex]; 
	var errLine = gATL.errorsLines[gATL.lessonNum][gATL.backspaceNumIndex];
	scrLine = scrLine.replace(/  /g, " ");
	scrLine = scrLine.replace(/  /g, " ");			// remove double blanks  
	errLine = errLine.replace(/  /g, " ");
	errLine = errLine.replace(/  /g, " ");
	if(''+scrLine.charAt(0)==' ') {scrLine = scrLine.substring(1, scrLine.length);}
	if(''+errLine.charAt(0)==' ') {errLine = errLine.substring(1, errLine.length);}
	var scrsArray = scrLine.split(" ");
	var errsArray = errLine.split(" ");
	var score_total = 0; 
	var error_total = 0;
	
	gATL.hii_score = 1 * scrsArray[0];  //  start with the first, then compare with the other scores
	gATL.low_score = 1 * scrsArray[0];
	
	for(var i = 0; i < scrsArray.length-1; i++) {      // compare with the other scores
		score_total = score_total + (1 * scrsArray[i]);
		error_total = error_total + (1 * errsArray[i]);
		if(1 * scrsArray[i] > gATL.hii_score) { gATL.hii_score = 1 * scrsArray[i]; }
		if(1 * scrsArray[i] < gATL.low_score) { gATL.low_score = 1 * scrsArray[i]; }
	}
	gATL.avg_score = score_total/(scrsArray.length-1);
	gATL.avg_error = error_total/(errsArray.length-1);
	gATL.avg_score = Math.round(gATL.avg_score * 10) / 10;
	gATL.avg_error = Math.round(gATL.avg_error * 10) / 10;
	gATL.avg_score = gATL.avg_score.toFixed(1);	// changes 40 to 40.0 
	gATL.avg_error = gATL.avg_error.toFixed(1);	// changes  3 to  3.0 
},
displayAverages: function() {   
	var str_avg_score = "" + gATL.avg_score;
	var str_avg_error = "" + gATL.avg_error;
	if(str_avg_score == "NaN") {  str_avg_score = "0";  }
	if(str_avg_error == "NaN") {  str_avg_error = " ";  } 
	if(gATL.lblScores.value.length > 58) {
		if(gATL.avg_score > gATL.best_avg[gATL.lessonNum][gATL.backspaceNumIndex] * 1) { 
			gATL.best_avg[gATL.lessonNum][gATL.backspaceNumIndex] = gATL.avg_score;
		}
		if(gATL.hii_score > gATL.best_hii[gATL.lessonNum][gATL.backspaceNumIndex] * 1) { 
			gATL.best_hii[gATL.lessonNum][gATL.backspaceNumIndex] = gATL.hii_score;
		}
		if(gATL.low_score > gATL.best_low[gATL.lessonNum][gATL.backspaceNumIndex] * 1) { 
			gATL.best_low[gATL.lessonNum][gATL.backspaceNumIndex] = gATL.low_score;
		}
		if(gATL.avg_error<gATL.best_err[gATL.lessonNum][gATL.backspaceNumIndex]*1 || gATL.best_err[gATL.lessonNum][gATL.backspaceNumIndex]==0) {      
			gATL.best_err[gATL.lessonNum][gATL.backspaceNumIndex] = gATL.avg_error;
		}
	}
	if(str_avg_score == "0") {
		gATL.lblCurrent.value = "";
	}
	else {
	var current           = ""          + gATL.align(str_avg_score);
		current = current + "    "      + gATL.align(gATL.hii_score);
		current = current + "       "   + gATL.align(gATL.low_score); 
		current = current + "        "  + gATL.align(str_avg_error);
		gATL.lblCurrent.value  = current;
	}
	if(gATL.best_avg[gATL.lessonNum][gATL.backspaceNumIndex] == 0) {
		gATL.lblBest.value = "";
	}
	else {
		gATL.newBests=                ""         + gATL.align(gATL.best_avg[gATL.lessonNum][gATL.backspaceNumIndex]);
		gATL.newBests= gATL.newBests+ "    "     + gATL.align(gATL.best_hii[gATL.lessonNum][gATL.backspaceNumIndex]);   
		gATL.newBests= gATL.newBests+ "       "  + gATL.align(gATL.best_low[gATL.lessonNum][gATL.backspaceNumIndex]);
		gATL.newBests= gATL.newBests+ "        " + gATL.align(gATL.best_err[gATL.lessonNum][gATL.backspaceNumIndex]);
	}
},

trimLessonsMenu:     function() {   // called from load,  to remove blank items from the menu
	var theMenu = document.getElementById("mnu_lessonsPopup-2");
	for(var jj=27; jj < 81; jj++) {
		var theID = 'item' + jj;
		var item = document.getElementById(theID);
		if(item.label == "") {
			theMenu.removeChild(item);
		}
	}
},
calculateWPM: function() {
	gATL.total_seconds = Math.round(gATL.total_quarter_seconds/4);	 
	if(gATL.quarterSeconds != 0) {
		gATL.running = false;
		if(gATL.speedType == "CPM") {
			gATL.wpm = (gATL.answer.length * 240)/gATL.quarterSeconds;
		}
		else {		// it would be "WPM"     	5 letters is 1 word,  240 quarter-seconds is 1 minute,	240/5 is 48
			gATL.wpm = (gATL.answer.length * 48)/gATL.quarterSeconds;
		}
		gATL.wpm = Math.round(gATL.wpm);
		if(gATL.wpm < 10)	{gATL.wpm="  " + gATL.wpm;}
		else if(gATL.wpm<100){gATL.wpm=" "  + gATL.wpm;}
		if(gATL.errorCount < 10)	{gATL.errorCount="  " + gATL.errorCount;} 
		else if(gATL.errorCount<100){gATL.errorCount=" "  + gATL.errorCount;} 
	}  
 },
align: function(numbr){             // to line up the displays of the avg, low, and hi scores
	var st = "" + numbr;
	while(st.length<5){
		st = " " + st;
	}
	return st;
},
updateTimeSpentTypingToday: function() {	// for the small box in the upper-right corner, displaying the stint-time and typing-time
	gATL.total_minutes = Math.floor(gATL.total_seconds/60);
	gATL.total_sec_mod = gATL.total_seconds % 60;
	gATL.total_hours = Math.floor(gATL.total_minutes/60);
	gATL.total_min_mod = gATL.total_minutes % 60;
	if(gATL.total_sec_mod < 10) {gATL.total_sec_mod = '0' + gATL.total_sec_mod;}
	if(gATL.total_min_mod < 10) {gATL.total_min_mod = '0' + gATL.total_min_mod;}
	
	gATL.stint_seconds = gATL.total_seconds - gATL.loaded_seconds;
	
	gATL.stint_minutes = Math.floor(gATL.stint_seconds/60);
	gATL.stint_sec_mod = gATL.stint_seconds % 60;
	gATL.stint_hours = Math.floor(gATL.stint_minutes/60);
	gATL.stint_min_mod = gATL.stint_minutes % 60;
	
	if(gATL.stint_sec_mod < 10) {gATL.stint_sec_mod = '0' + gATL.stint_sec_mod;}
	if(gATL.stint_min_mod < 10) {gATL.stint_min_mod = '0' + gATL.stint_min_mod;}
	
	gATL.timeTypingString1 = gATL.stint_hours +':'+gATL.stint_min_mod+':'+gATL.stint_sec_mod;
	gATL.timeTypingString2 = gATL.total_hours +':'+gATL.total_min_mod+':'+gATL.total_sec_mod;
	
	if(gATL.total_hours == 0) {
		gATL.timeTypingString1 = gATL.timeTypingString1.substring(2);   // changes 0:12:34 to 12:34
		gATL.timeTypingString2 = gATL.timeTypingString2.substring(2);
		if(gATL.timeTypingString2.substring(0,1) == "0") {
			gATL.timeTypingString1 = gATL.timeTypingString1.substring(1);
			gATL.timeTypingString2 = gATL.timeTypingString2.substring(1);  //  changes 03:45 to 3:45
		}
		if(gATL.timeTypingString1.substring(0,2) == "00") {
			gATL.timeTypingString1 = " 0" + gATL.timeTypingString1.substring(2);
		}	
		if(gATL.timeTypingString1.substring(0,1) == "0" && gATL.timeTypingString1.length == 5) {
			gATL.timeTypingString1 = " " + gATL.timeTypingString1.substring(1);
		}		
	}
	setTimeout("gATL.lblStint.value = gATL.timeTypingString1", 800);
	setTimeout("gATL.lblTotal.value = gATL.timeTypingString2", 800);	
	
},  
checkTheTimeOfDay: function() {     // display time of day if 0 or 30 minutes
	var dt = new Date();
	dt = new Date(dt.getYear(), dt.getMonth(), dt.getDate(), dt.getHours(), dt.getMinutes());
	var hr = 0  + dt.getHours();
	var mi = "" + dt.getMinutes();
	// if( mi % 2 == 0 ) {			// when testing it, every 2 minutes 
	if(mi == 0 || mi == 30) {       // every 30 minutes
		var ampm = "AM";
		if(hr > 11) {	ampm = "PM";  }	
		if(hr == 0) {	hr = 12;		}
		if(hr > 12) {	hr = hr - 12  }
		var theMinutes = "" + mi;
		if(mi < 10) { theMinutes = "0" + mi; }
		var theHours = "" + hr;
		if(hr < 10) { theHours = " " + hr;	}
		var tim = '	' + theHours + ':' + theMinutes + ' ' + ampm;
		gATL.txtPrompt.value = " " + tim + " " + tim + " " + tim + " " + tim;   // displays the time of day if on the half hour
		gATL.txtAnswer.value = " " + tim + " " + tim + " " + tim + " " + tim;
	}
}
}





















































